// mfc_glView.h : interface of the CMfc_glView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MFC_GLVIEW_H__B0757D0F_C73F_4E84_989C_4805EDC8355A__INCLUDED_)
#define AFX_MFC_GLVIEW_H__B0757D0F_C73F_4E84_989C_4805EDC8355A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "robot.h"
//#include "MainFrm.h"
#include "mfc_glDoc.h"
#include "DglView.h"
#include <afxtempl.h>


//---------------------------------------------------------------------------
#define NB_SUBDIV_INIT 32
#define NB_SUBDIV_MAX 64

#define BLACK_INDEX     0
#define RED_INDEX       13
#define GREEN_INDEX     14
#define BLUE_INDEX      16
/* Identifiants des listes d'affichage */
#define Roue    1
#define RoueTorique    2
#define TigeD	3
#define Robot2Chassis 4
#define Repere 5
#define Terrain	6
#define Robot4Chassis	7
#define RobotKChassis	8

class CMfc_glView : public CView
{
protected: // create from serialization only
	CMfc_glView();
	DECLARE_DYNCREATE(CMfc_glView)

// Attributes
public:
	CMfc_glDoc* GetDocument();
	CMainFrame * pMainframe;
	HGLRC m_hRC;
  bool	afficheRepere, areteTransv, faceArriere;
  bool	menuAffichageGlview, MouseMovesScreen, MouseRotatesScreen;
  int  OldMouseX, OldMouseY;
	int nbSubdiv; /* Nombre de subdivisions du maillage */
  bool m_animate;
  double  t, dt;
  float xv, zv, zpos, yrot, xrot, echelleVert, CameraMoveStep;
	GLuint texture1, textureUHP;
	unsigned char image[256][256][3];
	TRobot2 *	* ListeRobots;
	int NRobots;			// nombre de robots
	int RobSel, NewRobSel;									// robot selectionn
	TRobot2 * Rob2;							// un robot2 pour generer et compiler les objets OpenGL
// Operations
public:
	void UpdateStatusBarRobSel();
	void FillCBListe();
	GLvoid CreateObjects();
	void SetupTextures();
	GLvoid initializeGL(GLsizei width, GLsizei height);
	void DrawScene();
	void CalculateFrameRate();
	void MiseAjourDlgView();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMfc_glView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMfc_glView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMfc_glView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnDestroy();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnRunAnimate();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnRunReset();
	afx_msg void OnAffichageGlview();
	afx_msg void OnUpdateAffichageGlview(CCmdUI* pCmdUI);
	afx_msg void OnRunResetview();
	afx_msg void OnHelp();
	afx_msg void OnSelRobot();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
public:
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
public:
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
public:
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
public:
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
public:
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
};

#ifndef _DEBUG  // debug version in mfc_glView.cpp
inline CMfc_glDoc* CMfc_glView::GetDocument()
   { return (CMfc_glDoc*)m_pDocument; }
#endif

//---------------------------------------------------------------------------
extern    CMfc_glView * Mfc_glView;
//---------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MFC_GLVIEW_H__B0757D0F_C73F_4E84_989C_4805EDC8355A__INCLUDED_)
